# ArgoCD

## GitOps

#### What is GitOps?
    
GitOps is a set of best practices where the entire code delivery process is controlled via Git, including infrastructure and application definition as code and automation to complete updates and rollbacks.Before getting started with GitOps, few prerequisites can be - 
- containers and Kubernetes
- Helm and Kustomize

Some pros of GitOps -
- Faster deployments
- Safer deployments
- Easier rollbacks
- Straightforward auditing
- Better traceability
- Eliminating configuration drift

#### GitOps Principles
    
- Declarative
- Versioned and Immutable
- Pulled Automatically
- Continuously Reconciled

#### Flow of K8s Deployment via GitOps

- A developer commits source code for the application and the CI system creates a container image that is pushed to a registry.
- Nobody has direct access to the Kubernetes cluster. There is a second Git repository that has all manifests that define the application.
- Another human or an automated system changes the manifests in this second Git repository.
- A GitOps agent is deployed on the cluster.
- The GitOps agent is monitoring one or more Git repositories that define applications and contain Kubernetes manifests (or Helm charts or Kustomize files).
- Once a Git commit happens the GitOps agent is instructing the cluster to reach the same state as what is described in Git.
- Developers, operators. and other stakeholders perform all changes via Git operations and never directly touch the cluster (or perform manual kubectl commands).

#### Some points to observe
    
- The state of the cluster is always described in Git. Git holds everything for the application and not just the source code.
- There is no external deployment system with full access to the cluster. The cluster itself is pulling changes and deployment information.
- The GitOps controller is running in a constant loop and always matches the Git state with the cluster state.

#### GitOps Usecases
    
- Continuous deployment of applications
- Continuous deployment of cluster resources
- Continuous deployment of infrastructure
- Detecting/Avoiding configuration drift
- Multi-cluster deployments

## ArgoCD Basics

#### Intro  
- ArgoCD implements the GitOps principles in the following flow - 
     
    - You install Argo CD as a controller in the Kubernetes cluster. Usually you install Argo CD on the same cluster that it manages. It is also possible for Argo CD to manage external clusters.
    - You store your manifests in Git. Argo CD is agnostic on the type of manifests you can use. It supports plain Kubernetes manifests, Helm charts, Kustomize definitions, and other templating mechanisms.
    - You create an Argo CD application by defining which Git repository to monitor and to which cluster/namespace this application should be installed.
    - From now on, Argo CD monitors the Git repository, and when there is a change, it automatically brings the cluster to the same state.
    - Optionally Argo CD can deploy applications to other clusters (and not just the one on which it is installed).

#### Installation & Setup

##### Deploy Argo CD to Kubernetes
- Use the following commands to install ArgoCD on your k9s cluster which will create a new namespace, argocd, where Argo CD services and application resources will live.
    ```
    kubectl create namespace argocd
    kubectl apply -n argocd -f https://raw.githubusercontent.com/codefresh-contrib/gitops-certification-examples/main/argocd-noauth/install.yaml
    ```
    ![](./ss/01_argocd_Installation.png)
- To view the deployment enter
    ```
    kubectl get pods -n argocd
    ```
    ![](./ss/02_argocd_CheckDeployments.PNG)

##### Expose the Argo CD UI
- By default, Argo CD is only accessible from within the cluster. To expose the UI to users you can utilize any of the standard Kubernetes networking mechanisms such as
    - Ingress (recommended for production)
    - Load balancer (affects cloud cost)
    - NodePort (simple but not very flexible)

- For this exercise, a Nodeport service is used. In a production environment an Ingress is used.
    ```
    kubectl apply -f service.yml
    ```
    ![](./ss/03_argocd_ApplyService.PNG)
    ![](./ss/04_argocd_ExposedGUI.PNG)
     where the yml file looks like this
    ```
    apiVersion: v1
    kind: Service
    metadata:
    labels:
        app: argocd-server
    managedFields:
    name: argocd-server-nodeport
    namespace: argocd
    spec:
    ports:
    - nodePort: 30443
        port: 8080
        protocol: TCP
    selector:
        app.kubernetes.io/name: argocd-server
    type: NodePort
    ```
    ![](./ss/05_argocd_ServiceFile.PNG)

##### Log in the Argo CD UI
- Argo CD initially has an admin user with an autogenerated password. You can get the admin password from the default Configmap. In this case authentication has been disabled in the ArgoCD UI
    ```
    kubectl -n argocd get secret argocd-initial-admin-secret -o jsonpath="{.data.password}" | base64 -d > admin-pass.txt
    ```
    ![](./ss/06_argocd_LogintoGUI.PNG)

##### Argo CD CLI
- It provides a CLI too, it just needs to be installed.
    ```
    curl -sSL -o /usr/local/bin/argocd https://github.com/argoproj/argo-cd/releases/download/v2.1.5/argocd-linux-amd64
    chmod +x /usr/local/bin/argocd
    ```
    ![](./ss/06_argocd_LogintoGUI.PNG)
##### Login with the CLI
- Before we can use your CLI we need to authentication against our own Argo CD instace.In a production environment you might have different authentication options and also change the default admin password (or remove the admin account completely).
- Authenticate this way
    ```
    argocd login localhost:30443 --insecure
    ```
    ![](./ss/07_argocd_LogintoCLI.PNG)
- Verify by few commands
    ```
    argocd version
    argocd app list
    ```
    ![](./ss/08_argocd_LogintoCliAndVerify.PNG)

#### Creating an application
Creating an app using ArgoCD UI is a way and the same can be done using the CLI too.
```
argocd app create {APP NAME} \
--project {PROJECT} \
--repo {GIT REPO} \--path {APP FOLDER} \
--dest-namespace {NAMESPACE} \
--dest-server {SERVER URL}
```
Once this is done, the status and the configuration of the app can be verified 
```
argocd app list 
```
or for more info
```
argocd app list {app name}
```
![](./ss/09_argocd_CreatedApp.PNG)
![](./ss/10_argocd_AppMap.PNG)
#### Syncing an application
Initially the status says **OutOfSync** because there doesn't exist any k8s resources. Once the resources has been allocated the sync can be arranges using the UI and using the CLI too
```
argocd app sync {app name}
```
For verification you can run the below command, this app will be having **Running** status  if the sync goes correct.
```
kubectl -n {namespace} get all
```

![](./ss/12_argocd_AppDeployViaCLI.PNG)


When you will turn on the sync it will verify whether the states are in sync between kubernetes ArgoCD sees that the cluster is empty and it will deploy your application in order to make the cluster have the same state as what is in Git.


![](./ss/11_argocd_AppDeployed.PNG)




